#=======================================================================
#	$Id$
#	Tied hash with cached access
#=======================================================================
package PythonTech::Triples::Cached;
use strict;
use PythonTech::Triples::TiedHash;

sub new {
    my $class = shift;
}

sub _get {
    my($self, $key) = @_;
    my $val = $self->{'lru'}->get($key);
    return $val if defined $val;
    $val = $self->SUPER::_get($key);
    return unless defined $val;
    $self->{'lru'}->put($key, $val);
    return $val;
}

sub _set {
    my($self, $key,$val) = @_;
    $self->SUPER::_set($key, $val);
    if (defined $val) {
	$self->{'lru'}->put($key, $val);
    } else {
	$self->{'lru'}->delete($key);
    }
}

1;
